<?php
class controller_component_universal_sitemap_generator extends component {
    
    public function action_index() {
        $this->page['title'] = 'Генератор sitemap.xml';
        $this->page['html'] = $this->load_view();
        return $this->page;
    }

    public function action_ajax_getfile() {
        if (isset($this->url['params']['url'])) echo file_get_contents(base64_decode($this->url['params']['url']));
        die();
    }

    public function action_ajax_create_sitemap_xml() {
        if (isset($_POST['map']) && isset($_POST['saveAtRoot']) && isset($_POST['isArchive'])) {
            $map = json_decode($_POST['map']);
            $xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
            foreach ($map as $url) $xml .= "\t<url><loc>$url</loc></url>\n";
            $xml .= "</urlset>";

            $ext = '';
            if ($_POST['isArchive'] == 1) {
                $xml = gzencode($xml, 9);
                $ext = '.gz';
            }

            if ($_POST['saveAtRoot'] == 1) {
                file_put_contents(ROOT_DIR.'/sitemap.xml'.$ext, $xml);
                echo 'Индексация завершена. Карта сайта создана в корне сайта.';
            } else {
                file_put_contents(ROOT_DIR.'/temp/sitemap.xml'.$ext, $xml);
                echo 'Индексация завершена. <a href="'.SITE_URL.'/temp/sitemap.xml'.$ext.'" target="_blank">Скачать карту</a>.';
            }
        }
        die();
    }
}